/* 
 * File:   addr_pivl_set_skiplist.h
 * Author: parkcs
 *
 * Created on May 10, 2011, 4:13 PM
 */

#ifndef ADDR_PIVL_SET_SKIPLIST_H
#define	ADDR_PIVL_SET_SKIPLIST_H

#include "interval_set.h"

typedef pivl_set* ppis;
pivl_pool* addr_skiplist_print_pool = NULL;
    
#define KEYTYPE addr
#define KEY_LT_FN(x,y)  ((x) < (y))
#define KEY_EQ_FN(x,y)  ((x) == (y))
#define DATATYPE ppis
#define KEYTYPE_PRINT_FN(x)         printf("0x%010" PRIx64, x)
#define DATATYPE_PRINT_FN(x)        pivl_set_print(addr_skiplist_print_pool, x)
#define EDGEDATATYPE_PRINT_FN(x)    pivl_set_print(addr_skiplist_print_pool, x)
#define EDGEDATATYPE ppis
#include "../defs/skiplist.def"



#endif	/* ADDR_PIVL_SET_SKIPLIST_H */

