/*
 * interval.h
 *
 *  Created on: Sep 20, 2010
 *  Updated on: May 25, 2011
 *      Author: parkcs
 */

#ifndef INTERVAL_H_
#define INTERVAL_H_

typedef uint64_t addr;
typedef struct addr_interval_t {
	addr start;
	addr end;
} addr_interval;

#define is_in_interval(p, i)	  ((i).start<=(p) && (p)<(i).end)
#define overlaps_interval(i1, i2) ((i1).start<(i2).end && (i2).start<(i1).end)
#define contains_interval(i1, i2) ((i1).start<=(i2).start && (i1).end>=(i2).end)
#define eq_interval(i1, i2)  	  ((i1).start==(i2).start && (i1).end==(i2).end)

#endif /* INTERVAL_H_ */
