#include <upc.h>

shared int tot_wait_time = 0;

int main()
{
    int local_wait = 0;
    upc_lock_t* the_lock = upc_all_lock_alloc();

    for(int i = 0; i < 50; i++) {
        
        while(!upc_lock_attempt(the_lock))
            ++local_wait;

        tot_wait_time += local_wait;

        upc_unlock(the_lock);

        local_wait = 0;

        upcr_notify(42, 0);

        while(!upcr_try_wait(42, 0)) {
            ++local_wait;
        }
    }

    if (MYTHREAD == 0) {
        printf("Total wait: %d\n", tot_wait_time);
    }

    upc_barrier;
}

