/* weakcheck.upc
 * Authors - Chang-Seo Park (parkcs@cs.berkeley.edu)
 *
 * Makes successively weaker accesses (to verify weakness check in Thrille)
 */

#include <upc.h>
#include <stdio.h>

struct data {
    int x;
    int y;
    int z;
};

shared [] struct data B[4];

int main(int argc, char* argv[])
{
    struct data local;
    struct data locala[4];
    B[2].y = 3;
    int old = B[2].y;

    upc_memget(locala, B, sizeof(struct data)*4); 
    
    upc_memget(&local, B+2, sizeof(struct data));
    upc_memput(B+2, &local, sizeof(struct data));


    upc_barrier;
    return 0;
}


